generic
   type Message is private;
   --  the "generic" tag makes a package
   --+ similar to a C++ template, which can
   --+ be instantiated by providing a concrete
   --+ implementation for the given attributes
   --+ (type Message in this case)
package Broadcasts is

   protected type Broadcast is
      procedure Send (A_Message : Message);
      -- the semantics we realize here is
      -- that the arrived message is copied
      -- (broadcast) to all processes that
      -- were queued waiting for it
      entry Receive (A_Message :    out Message);
   private
      Arrived : Boolean := False;
      The_Message : Message;
   end Broadcast;

end Broadcasts;

